Affected QGIS version:3.1(master) Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27049
Description

First issue so my apologies if | commit any community faux pas.

I've been working quite a lot with the new Python-based QgsVectorDataProvider. One thing | cannot get working is the Spatial Index.

If I insert a bunch of features without a spatial index, they render, are queryable, appear in the table. If | "Create Spatial Index" it
announces that one has been created, but my features all immediately disappear. It's as if every query is returning no results.

One thing | noticed in the code was this line: https://github.com/qgis/QGIS/blob/master/tests/src/python/provider_python.py#L.390

It appears to be iterating over the keys (feature ids) and attempting to add features to the index by passing integers, not features. Looking
at the docs, it doesn't look like there's a valid override for that. Signature 1 accepts a feature and Signature 2 accepts anid AND a
bounds. https://qgis.org/api/3.0/classQgsSpatiallndex.html#aba57698626fcd78c42fb00570e6cbceb

So | dug deeper, trying to fix this myself with no luck. | instead pass it the feature, but nothing seems to be any different. | think one issue |
have is that because of Qt5 bindings, sometimes errors seem to pass silently. Another issue is that this is new code for me and | haven't
used QGIS or Qt in years. So this may be a me issue.

| read through the unit tests: https://github.com/qgis/QGIS/blob/master/tests/src/python/test_provider _python.py. It looks like none of them
end up testing that features are queryable. So I'm not confident this has worked in the past?

I'm pretty motivated to help address this, so once | learn how to compile and run tests (and effectively have a dev environment for QGIS in
Ubuntu 16.04), | will keep digging.

Associated revisions

Revision d84471b1 - 2018-06-19 02:04 AM - Andrew Blakey

Addressed two issues that caused createSpatiallndex() to fail. Fixes #19220

History

#1 - 2018-06-18 09:50 PM - Andrew Blakey
- Assignee set to Andrew Blakey

| found the issues. | will attempt to get an environment together and make a pull request.

https://github.com/qgis/QGIS/blob/master/tests/src/python/provider_python.py#L95
fid() is always 0.
_fid() is what was intended.

Also as described in the initial bug report, the iterator in createSpatiallndex needs to iterate over values, not keys.

#2 - 2018-06-19 08:21 AM - Anonymous
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|d84471b149b0eea52e6d4c84eb9ce5¢533bd0b98.
